unit Sub;

interface

uses Windows, Graphics;

function CreateBitmapRgn(Bmp: TBitmap): HRGN;

implementation

function CreateBitmapRgn(Bmp: TBitmap): HRGN;

	function IsEqualRGB(Data1, Data2: PRGBTriple): Boolean;
	begin
		Result := (Data1.rgbtBlue  = Data2.rgbtBlue) and
							(Data1.rgbtGreen = Data2.rgbtGreen) and
							(Data1.rgbtRed   = Data2.rgbtRed);
	end;

var
	TempBmp: TBitmap;
	p, clMask: PRGBTriple;
	xStart, x, y: Integer;
	LineRgn: HRGN;
begin
	TempBmp := TBitmap.Create;
	try
		TempBmp.Assign(Bmp);
		TempBmp.PixelFormat := pf24bit;
		clMask := TempBmp.ScanLine[0];

		Result := CreateRectRgn(0, 0, 0, 0);
		try
			for y := 0 to TempBmp.Height - 1 do
			begin
				p := TempBmp.ScanLine[y];

				x := 0;
				while x < TempBmp.Width do
				begin
					xStart := x;
					while (xStart < TempBmp.Width) and (IsEqualRGB(p, clMask)) do
					begin
						Inc(xStart);
						Inc(p);
					end;

					x := xStart;
					while (x < TempBmp.Width) and (not IsEqualRGB(p, clMask)) do
					begin
						Inc(x);
						Inc(p);
					end;

					if x <> xStart then
					begin
						LineRgn := CreateRectRgn(x, y, xStart, y + 1);
						CombineRgn(Result, Result, LineRgn, RGN_OR);
						DeleteObject(LineRgn);
					end;
				end;
			end;
		except
			DeleteObject(Result);
			raise;
		end;
	finally
		TempBmp.Free;
	end;
end;

end.

